/*
 * PDFlow -- filters_priv.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef filters_priv_h

#define filters_priv_h

#include "filters.h"

struct flt_interface {
	const char *name;
	enum s_status (*encode) (const struct obj_region *src, 
				 struct obj_region *dest,
				 struct xref_db *rdb,
				 struct obj *params);
	enum s_status (*decode) (const struct obj_region *src, 
				 struct obj_region *dest,
				 struct xref_db *rdb,
				 pdf_integer_t dl,
				 struct obj *params);
};

extern struct flt_interface flt_ident_ifc;
extern struct flt_interface flt_hex_ifc;
extern struct flt_interface flt_a85_ifc;
extern struct flt_interface flt_flate_ifc;
extern struct flt_interface flt_lzw_ifc;

#endif
