/*
 * PDFlow -- ident.c
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <string.h>
#include <stdlib.h>

#include "filters_priv.h"

static enum s_status encode (const struct obj_region *src, 
			     struct obj_region *dest,
			     struct xref_db *rdb,
			     struct obj *parms);
static enum s_status decode (const struct obj_region *src, 
			     struct obj_region *dest,
			     struct xref_db *rdb,
			     pdf_integer_t dl,
			     struct obj *parms);

struct flt_interface flt_ident_ifc = {
	FLT_IDENT, encode, decode
};

static enum s_status i (const struct obj_region *src, 
			struct obj_region *dest)
{
	size_t size;
	void *p;

	size = src -> end - src -> begin;
	p = malloc (size);
	if (p == NULL)
		return S_CSC_OUT_OF_MEMORY;

	memcpy (p, src -> begin, size);

	obj_init_malloc_region (dest, p, p + size);
	
	return S_CSC_OK;
}

static enum s_status encode (const struct obj_region *src, 
			     struct obj_region *dest,
			     struct xref_db *rdb,
			     struct obj *parms)
{
	return i (src, dest);
}

static enum s_status decode (const struct obj_region *src, 
			     struct obj_region *dest,
			     struct xref_db *rdb,
			     pdf_integer_t dl,
			     struct obj *parms)
{
	return i (src, dest);
}
