/*
 * PDFlow -- conv.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef conv_h

#define conv_h

#include "grid/grid.h"
#include "pdf/pdfi.h"
#include "pdf/pdfc.h"
#include "args.h"
#include "pdfdoc.h"

struct conv_sstate {

	struct pd_document *doc;

	struct pdfi_interpreter *pi;

	struct bt_cursor *spc;

	struct args_heur heur;

	struct args_margins amys;

	struct args_ranges ranges;
	
	int page, eof;

};

struct conv_dstate {

	struct pd_document *doc;

	struct args_output aout;

	struct v_selection sel;

	struct cobj_rect bounds;

	struct agc_context *agc;
};

struct conv {

	struct ref_owner owner;

	struct conv_sstate sstate;

	struct conv_dstate dstate;

	struct ob_bridge *ob;

	struct pdfc_compiler *pdc;

	FILE *rfp;

	/* feed_fun spec data */
	union {

		struct {
		} highlight;
	} ffd;
};

enum s_status conv_run (const char *sfname, const char *dfname, 
			struct args *args);

#endif
