/*
 * PDFlow -- objbr.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef objbr_h

#define objbr_h

#include "btree.h"
#include "fmt/obj.h"

struct ob_bridge {

	ref_t refs;

	struct xref_db *srdb, *drdb;

	struct bt_tree *tree;

};

enum s_status ob_new (struct ob_bridge **ob, struct xref_db *srdb, 
		      struct xref_db *drdb, struct ref_owner *p);

void ob_ref (struct ob_bridge *ob, struct ref_owner *p);
void ob_unref (struct ob_bridge *ob, struct ref_owner *p);

enum s_status ob_lookup (struct ob_bridge *ob, 
			 struct obj *sobj, struct obj *dobj);

#endif
