/*
 * PDFlow -- pdf-syn.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef __pdf_syn_h

#define __pdf_syn_h

#include "fmt/machine.h"
#include "fmt/obj.h"
#include "pdf-lex.h"

struct ps_parser;
struct xref_db;

typedef int (*ps_eval_feed) (struct pl_state *ps, pdf_ofs_t *limit,
			     void *closure);

enum s_status ps_build_obj (struct ps_parser *parser,
			    struct pl_state *ps, pdf_ofs_t limit,
			    struct obj *obj, enum obj_type ot);
enum s_status ps_serialize_obj (struct f_file *file, struct obj *obj);

enum s_status ps_eval (struct ps_parser *parser, m_trigger def_handler,
		       struct pl_state *ps, pdf_ofs_t limit,
		       void *ps_closure, ps_eval_feed feed, void *closure);
		       

enum s_status ps_create (struct xref_db *rdb, struct ps_parser **parser);
void ps_destroy (struct ps_parser *parser);

enum s_status ps_init (void);
void ps_cleanup (void);

#endif
