/*
 * PDFlow -- xref.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef XREF_STREAM
XREF_DESC_BEGIN (xref_stream_desc, NULL)
     XREF_S_ARRAY ("Filter", struct xref_obj_array, filter,
		   &xref_name_pstable, 1, 0, XREF_O)
     XREF_S_ARRAY ("DecodeParms", struct xref_obj_array, 
		   decode_parms, &xref_dictionary_pstable, 1, 0, XREF_O)
     XREF_FUNCTION_R ("F", struct fspec_specification, fspec,
		      &fspec_fs_pstable, 1, 2, XREF_O)
     XREF_S_ARRAY ("FFilter", struct xref_obj_array, 
		   ffilter, &xref_name_pstable, 1, 2, XREF_O)
     XREF_S_ARRAY ("FDecodeParms", struct xref_obj_array, fdecode_parms, 
		   &xref_dictionary_pstable, 1, 2, XREF_O)
     XREF_INTEGER ("DL", dl, -1, 1, 5, XREF_O)
XREF_DESC_END
/* Use DICTIONARY instead of STREAM to avoid infinite recursion
 * (STREAM implies calling xref_resolve_stream, which uses this field) */
XREF_F_STREAM (xref_stream_field, xref_stream_desc, 1, 0)
#undef XREF_STREAM
#endif

#ifdef XREF_TRAILER_INFO
XREF_DESC_BEGIN (xref_trailer_info_desc, NULL)
     XREF_INTEGER ("Size", size, -1, 1, 0, XREF_M)
XREF_DESC_END
XREF_F_DICTIONARY (xref_trailer_info_field, xref_trailer_info_desc, 1, 0)
#undef XREF_TRAILER_INFO
#endif

#ifdef XREF_BACK_PTR
XREF_DESC_BEGIN (xref_back_ptr_desc, NULL)
     XREF_INTEGER ("Prev", prev, -1, 1, 0, XREF_O)
     XREF_INTEGER ("XRefStm", xref_stm, -1, 1, 6, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (xref_back_ptr_field, xref_back_ptr_desc, 1, 0)
#undef XREF_BACK_PTR
#endif
