/*
 * PDFlow -- grdtree.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef grdtree_h

#define grdtree_h

#include "btree.h"
#include "fmt/obj.h"
#include "graph/gstate.h"

struct grd_tree {

	ref_t refs;

	struct xref_db *rdb;

	struct v_selection *sel;

	struct bt_tree *tree;

	struct t_cache_closure *cc;

	pdf_integer_t seq;

	const char *prefix;

	struct ob_bridge *ob;
};

struct grd_data {
	struct obj_bstr name;

	struct t_tag tag;

	struct obj obj;

	struct t_type *tcopy;
};

enum s_status grd_new (struct grd_tree **grd, const char *prefix,
		       struct xref_db *rdb, struct ob_bridge *ob,
		       struct t_cache_closure *cc,
		       struct v_selection *sel, struct ref_owner *p);

void grd_ref (struct grd_tree *grd, struct ref_owner *p);
void grd_unref (struct grd_tree *grd, struct ref_owner *p);

enum s_status grd_lookup (struct grd_tree *tree, struct t_tag *tag, 
			  struct obj *obj, struct xref_db *rdb,
			  struct obj *name, struct obj *xobj,
			  struct t_type ***tcopy);

enum s_status grd_rdict (struct grd_tree *tree, struct obj *dobj);

#endif
