/*
 * PDFlow -- gstate.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef GS_DASH_PATTERN
XREF_DESC_BEGIN (dash_pattern_field_desc, NULL)
     XREF_A_ARRAY ("1-DashArray", struct xref_real_array, dash_array,
		   &xref_real_pstable, 1, 0, XREF_M)
     XREF_INTEGER ("2-DashPhase", dash_phase, 0, 1, 0, XREF_M)
XREF_DESC_END
XREF_F_A_ARRAY (dash_pattern_field, dash_pattern_field_desc, 1, 0);
#undef GS_DASH_PATTERN
#endif

#ifdef GS_FONT
XREF_DESC_BEGIN (font_field_desc, NULL)
     GF_FONT_FIELD_R ("1-Font", font, 1, 0, XREF_M)
     XREF_REAL ("2-Size", size, 1, 1, 0, XREF_M)
XREF_DESC_END
XREF_F_A_ARRAY (font_field, font_field_desc, 1, 0);
#undef GS_FONT
#endif

#ifdef GS_TEXT_STATE
XREF_DESC_BEGIN (text_state_field_desc, NULL)
     GS_FONT_FIELD_R ("Font", font, 1, 3, XREF_O)
     XREF_BOOL ("TK", knockout, 0, 1, 4, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (text_state_field, text_state_field_desc, 1, 0);
#undef GS_TEXT_STATE
#endif

#ifdef GS_GRAPH_STATE
XREF_DESC_BEGIN (graph_state_field_desc, NULL)
     XREF_REAL ("LW", line_width, 1., 1, 3, XREF_O)
     XREF_INTEGER ("LC", line_cap, GS_LC_BUTT, 1, 3, XREF_O)
     XREF_INTEGER ("LJ", line_join, GS_LJ_MITER, 1, 3, XREF_O)
     XREF_REAL ("ML", miter_limit, 10., 1, 3, XREF_O)
     GS_DASH_PATTERN_FIELD_R ("D", dash_pattern, 1, 3, XREF_O)
     FUN_ENUM ("RI", rendering_intent, 
		&gs_rendering_intent_desc, 1, 3, XREF_O)
     XREF_REAL ("FL", flatness_tolerance, 1., 1, 3, XREF_O)
     XREF_BOOL ("OP", overprint_stroke, 0, 1, 0, XREF_O)
     XREF_BOOL ("op", overprint_nonstroke, 0, 1, 3, XREF_O)
     XREF_INTEGER ("OPM", overprint_mode, 0, 1, 3, XREF_O)
     FUN_ENUM ("BG", black_generation, &black_generation_desc, 1, 0, XREF_O)
#ifdef XREF_IMPLEMENTATION
     FUN_ENUM ("BG2", black_generation, &black_generation_desc, 1, 3, XREF_O)
#endif
     FUN_ENUM ("UCR", undercolor_removal, 
	       &undercolor_removal_desc, 1, 0, XREF_O)
#ifdef XREF_IMPLEMENTATION
     FUN_ENUM ("UCR2", undercolor_removal, 
	       &undercolor_removal_desc, 1, 3, XREF_O)
#endif
     XREF_S_ARRAY_DATA ("TR", struct fun_enum_array,
			transfer_function, &cobj_enum_pstable,
			&transfer_function_desc, 1, 0, XREF_O)
#ifdef XREF_IMPLEMENTATION
     XREF_S_ARRAY_DATA ("TR2", struct fun_enum_array,
			transfer_function, &cobj_enum_pstable,
			&transfer_function_desc, 1, 3, XREF_O)
#endif
     TO_ENUM ("HT", halftone_dictionary, 
	       &halftone_dictionary_desc, 1, 0, XREF_O)
     XREF_REAL ("SM", smoothness_tolerance, 0, 1, 3, XREF_O)
     XREF_BOOL ("SA", stroke_adjustment, 0, 1, 0, XREF_O)
     XREF_S_ARRAY_DATA ("BM", struct cobj_enum_array, blend_mode,
			&cobj_enum_pstable, &blend_mode_desc, 1, 4, XREF_O)
     TO_ENUM ("SMask", soft_mask, &soft_mask_desc, 1, 4, XREF_O)
     XREF_REAL ("CA", alpha_constant_stroke, 1, 1, 4, XREF_O)
     XREF_REAL ("ca", alpha_constant_nonstroke, 1, 1, 4, XREF_O)
     XREF_BOOL ("AIS", alpha_is_shape, 0, 1, 4, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (graph_state_field, graph_state_field_desc, 1, 0);
#undef GS_GRAPH_STATE
#endif

#ifdef GS_GSTATE
XREF_DESC_BEGIN (gstate_field_desc, NULL)
     XREF_TAG ("Type", "ExtGState", 1, 0, XREF_O)
     GS_GRAPH_FIELD_R ("", gstate, 1, 0, XREF_M)
     GS_TEXT_FIELD_R ("", tstate, 1, 0, XREF_M)
XREF_DESC_END
XREF_F_DICTIONARY (gstate_field, gstate_field_desc, 1, 0);
#undef GS_GSTATE
#endif
