/*
 * PDFlow -- gstree.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef gstree_h

#define gstree_h

#include "btree.h"
#include "fmt/obj.h"
#include "graph/gstate.h"

struct gst_tree {

	ref_t refs;

	struct xref_db *rdb;

	struct v_selection *sel;

	struct bt_tree *tree;

	pdf_integer_t seq;

	gs_keyset_t keyset;

};

struct gst_data {
	struct obj_bstr name;
	struct gs_state_key gkey, tkey;
	struct gs_tags tags;
	gs_keyset_t keyset;
	struct obj gs;
};

enum s_status gst_new (struct gst_tree **gst, struct xref_db *rdb,
		       struct v_selection *sel, struct ref_owner *p);

void gst_ref (struct gst_tree *gst, struct ref_owner *p);
void gst_unref (struct gst_tree *gst, struct ref_owner *p);

enum s_status gst_lookup (struct gst_tree *tree, 
			  struct gs_graph_state *gs, 
			  struct gs_text_state *tws,
			  struct obj *name,
			  struct obj *gsobj,
			  struct gs_tags *tags);

enum s_status gst_rdict (struct gst_tree *tree, struct obj *dobj);

#endif
