/*
 * PDFlow -- align.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef align_h

#define align_h

#include "graph/gstate.h"

struct gr_grid;
struct args_heur;

enum gr_al_align_type {
	
	GR_AT_NONE = 0,

	GR_AT_UNKNOWN,
	GR_AT_BEGIN,
	GR_AT_CENTER,
	GR_AT_JUSTIFIED,
	GR_AT_PROPORTIONAL,
	GR_AT_END,

	GR_AT__LAST__
};

/*
 * Paragraph info. This is what goes into the "atomic" grid's 
 * al field.
 */
struct gr_al_alignment {

	enum gr_al_align_type at, flush_at;

	pdf_real_t fhead, ftail, lhead, ltail;

	int size;

	enum gs_direction wdir, ldir;
};

struct gr_al_machine;

enum s_status gr_al_create_machine (struct gr_al_machine **dc,
				    struct args_heur *heur,
				    FILE *rfp);
void gr_al_destroy_machine (struct gr_al_machine *dc);

enum s_status gr_al_detect_alignment (struct gr_al_machine *dc,
				      struct gr_grid *grid, int page);

#endif
