/*
 * PDFlow -- layout.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef layout_h

#define layout_h

#include "grid/heur.h"
#include "grid/grid.h"

struct gr_layout_el {
	
	struct gr_layout_el *next, *prev;

	struct gr_region reg;

	pdf_integer_t occurrences;

	int pgsz, selected;
	pdf_integer_t *pages;
};

struct gr_layout {

	struct gr_layout_els {
		struct gr_layout_el *head, *tail;
	} north, east, west, south;

	pdf_real_t weight;

	int samples;

	struct args_heur *heur;
};

void gr_layout_init (struct gr_layout *gly, struct args_heur *heur);
enum s_status gr_layout_learn (struct gr_layout *gly, struct gspg_page *page);
void gr_layout_apply (struct gr_layout *gly, struct args_margins *amys);
void gr_layout_destroy (struct gr_layout *gly);


enum s_status gr_layout_setup_grid (struct gr_grid *grid,
				    struct cobj_rect *page_rect,
				    struct args_margins *amys,
				    struct args_heur *heur);

#endif
