/*
 * PDFlow -- region.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef region_h

#define region_h

#include "grid/area.h"

struct gr_region {

	struct gr_region *next;

	pdf_real_t lo, hi;

	pdf_real_t xlo, xhi;
};

int gr_reg_size (struct gr_region *reg);

pdf_real_t gr_reg_width (struct gr_region *reg);

void gr_reg_destroy (struct gr_region *reg);

void gr_reg_sort (struct gr_region *reg);

pdf_bool_t gr_reg_has_x_gap (struct gr_region *reg);

enum s_status gr_reg_dup (struct gr_region **dreg, 
			  struct gr_region *sreg);

enum s_status gr_reg_add (struct gr_region **reg, 
			  struct gr_region *spec);

enum s_status gr_reg_get (struct a_area *parent,
			  struct args_heur *heur,
			  struct gr_region **hregp, 
			  struct gr_region **vregp,
			  pdf_bool_t *hin, pdf_bool_t *vin);

void gr_reg_limits (struct gr_region *limits, struct gr_region *reg);

#endif
