/*
 * PDFlow -- squeeze.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef squeeze_h

#define squeeze_h

#include "grid/heur.h"
#include "grid/grid.h"

struct gr_squeeze_result {

	struct cobj_rect rect, bounds;

	struct gs_point origin;

	pdf_real_t badness;
};

struct gr_squeeze_option {

	struct cobj_rect avail;

	struct gr_squeeze_result sqr;

};

void gr_sq_homog_probe (struct gr_grid *grid, pdf_real_t pspace,
			struct args_output *aout,
			int options, struct gr_squeeze_option *opt);

enum s_status gr_sq_homog_squeeze (struct gr_grid *grid, 
				   struct agc_context *agc,
				   struct gr_squeeze_option *opt);

#endif
