/*
 * PDFlow -- hash.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef hash_h

#define hash_h

#include "status.h"

#define HASH_SIZE 16

struct hash {
	unsigned char data [HASH_SIZE];
};

struct hash_status;

enum s_status hash_init (struct hash_status **hs);
enum s_status hash_update (struct hash_status *hs, 
			   const void *data, unsigned len);
enum s_status hash_final (struct hash_status *hs, struct hash *data);

#endif
