/*
 * PDFlow -- pdfc.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef pdfc_h

#define pdfc_h

#include "fmt/obj.h"
#include "fmt/objbr.h"
#include "graph/gspg.h"

struct pdfc_compiler;

enum s_status pdfc_create (struct cat_catalog *cat,
			   struct ob_bridge *ob,
			   struct v_selection *sel,
			   struct pdfc_compiler **pdc);
void pdfc_destroy (struct pdfc_compiler *pdc);

enum s_status pdfc_compile (struct pdfc_compiler *pdc,
			    struct gspg_page *input,
			    struct pg_page *output);

enum s_status pdfc_finalize (struct pdfc_compiler *pdc);

#endif
