/*
 * PDFlow -- pdfi.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef pdfi_h

#define pdfi_h

#include "args.h"
#include "graph/gspg.h"

struct pdfi_interpreter;

enum s_status pdfi_create (struct xref_db *rdb,
			   struct pdfi_interpreter **pi);
void pdfi_destroy (struct pdfi_interpreter *pi);

enum s_status pdfi_get_area (struct rd_resdict *rd,
			     struct obj *stream,
			     struct cobj_rect *rect,
			     pdf_real_t *wx,
			     pdf_real_t *wy);

enum s_status pdfi_eval (struct pdfi_interpreter *pi,
			 struct cat_catalog *cat,
			 struct pg_page *input,
			 struct gspg_page **output,
			 struct ref_owner *p);

#endif
