/*
 * PDFlow -- pdfdoc.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef pdfdoc_h

#define pdfdoc_h

#include "refs.h"
#include "fmt/objbr.h"
#include "types/catalog.h"
#include "types/trailer.h"
#include "version.h"
#include "status.h"

struct pd_document {

	ref_t refs;

	struct xref_db *rdb;

	struct tri_trailer *trailer;
};


enum s_status pd_add_selection (struct v_selection *sel, 
				struct v_pref *pref);

enum s_status pd_init (struct pd_document **doc, struct ref_owner *p);
enum s_status pd_read (struct pd_document *doc, const char *fname);
enum s_status pd_creat (struct pd_document *doc, const char *fname,
			struct v_selection *sel);
enum s_status pd_scratch (struct pd_document *doc, struct v_selection *sel);
enum s_status pd_sync_start (struct pd_document *doc, struct v_selection *sel);
enum s_status pd_sync_end (struct pd_document *doc, struct v_selection *sel);
enum s_status pd_sync (struct pd_document *doc, struct v_selection *sel);

enum s_status pd_derive (struct pd_document *doc, struct pd_document *sdoc,
			 struct ob_bridge *ob);

void pd_ref (struct pd_document *doc, struct ref_owner *p);
void pd_unref (struct pd_document *doc, struct ref_owner *p);
void pd_unlink (struct pd_document *doc, struct ref_owner *p);

#endif
