/*
 * PDFlow -- psi.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef psi_h

#define psi_h

#include "fmt/obj.h"
#include "fmt/file.h"
#include "types/cmap.h"
struct psi_interpreter;

enum s_status psi_create (struct psi_interpreter **pi);
void psi_destroy (struct psi_interpreter *pi);

enum s_status psi_clone (struct psi_interpreter *spi,
			 struct psi_interpreter **dpi);


enum s_status psi_eval (struct psi_interpreter *pi,
			struct f_file *file);

enum s_status psi_add_cmap (struct psi_interpreter *pi,
			    struct f_file *file,
			    struct ref_owner *p,
			    struct cmap **cmap);

enum s_status psi_add_cmap_dir (struct psi_interpreter *pi,
				const char *dir);

enum s_status psi_get_cmap (struct psi_interpreter *pi,
			    struct obj *name,
			    struct ref_owner *p,
			    struct cmap **cmap);

enum s_status psi_eval_f (struct psi_interpreter *pi,
			  struct f_file *file, 
			  int argin, struct obj *in,
			  int argout, struct obj *out);

#endif
