/*
 * PDFlow -- catalog.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef catalog_h

#define catalog_h

#include "types/types.h"
#include "types/page.h"
#include "types/oc.h"

enum cat_page_layout {

	CAT_PL_SINGLE_PAGE,
	CAT_PL_ONE_COLUMN,
	CAT_PL_TWO_COLUMN_LEFT,
	CAT_PL_TWO_COLUMN_RIGHT,
	CAT_PL_TWO_PAGE_LEFT,
	CAT_PL_TWO_PAGE_RIGHT
};

enum cat_page_mode {

	CAT_PM_USE_NONE,
	CAT_PM_USE_OUTLINES,
	CAT_PM_USE_THUMBS,
	CAT_PM_FULL_SCREEN,
	CAT_PM_USE_OC,
	CAT_PM_USE_ATTACHMENTS
};

struct cat_catalog {

	struct t_type t;

#include "catalog.tab.h"	
};

T_PROTOTYPES (cat, cat_catalog);

#define CAT_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct cat_catalog, field, \
                 &cat_pstable, major, minor, mand)

enum s_status cat_add_selection (struct v_selection *sel);
enum s_status cat_derive (struct cat_catalog *cat, struct cat_catalog *scat,
			  struct ob_bridge *ob);


#endif
