/*
 * PDFlow -- catalog.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

XREF_DESC_BEGIN(field_desc, NULL)
     XREF_TAG ("Type", "Catalog", 1, 0, XREF_M)
     XREF_OBJ ("Version", version, OT_NAME, 1, 4, XREF_O)
     XREF_OBJ ("Extensions", extensions, OT_DICTIONARY, 1, 0, XREF_O)
     PG_PAGES_FIELD_R ("Pages", pages, 1, 0, XREF_M)
     XREF_OBJ ("PageLabels", page_labels, OT_DICTIONARY, 1, 3, XREF_O)
     XREF_OBJ ("Names", names, OT_DICTIONARY, 1, 2, XREF_O)
     XREF_OBJ ("ViewerPreferences", vprefs, OT_DICTIONARY, 1, 2, XREF_O)
     COBJ_ENUM ("PageLayout", page_layout, page_layout_desc, 1, 0, XREF_O)
     COBJ_ENUM ("PageMode", page_mode, page_mode_desc, 1, 0, XREF_O)
     XREF_OBJ ("Outlines", outlines, OT_DICTIONARY, 1, 0, XREF_O)
     XREF_OBJ ("Threads", threads, OT_ARRAY, 1, 1, XREF_O)
     XREF_OBJ ("OpenAction", open_action, OT_ANY, 1, 1, XREF_O)
     XREF_OBJ ("AA", aa, OT_DICTIONARY, 1, 4, XREF_O)
     XREF_OBJ ("URI", uri, OT_DICTIONARY, 1, 1, XREF_O)
     XREF_OBJ ("AcroForm", acro_form, OT_DICTIONARY, 1, 2, XREF_O)
     XREF_OBJ ("MetaData", metadata, OT_STREAM, 1, 4, XREF_O)
     XREF_OBJ ("StructTreeRoot", struct_tree_root, 
	       OT_DICTIONARY, 1, 3, XREF_O)
     XREF_OBJ ("MarkInfo", mark_info, OT_ANY, 1, 4, XREF_O)
     XREF_OBJ ("SpiderInfo", spider_info, OT_DICTIONARY, 1, 3, XREF_O)
     TS_FIELD_I ("Lang", lang, 1, 4, XREF_O)
     XREF_OBJ ("OutputIntents", output_intents, OT_ARRAY, 1, 4, XREF_O)
     XREF_OBJ ("PieceInfo", piece_info, OT_DICTIONARY, 1, 4, XREF_O)
     OC_PROPERTIES_R ("OCProperties", oc_properties, 1, 5, XREF_O)
     XREF_OBJ ("Perms", perms, OT_DICTIONARY, 1, 5, XREF_O)
     XREF_OBJ ("Legal", legal, OT_DICTIONARY, 1, 5, XREF_O)
     XREF_OBJ ("Requirements", requirements, OT_ARRAY, 1, 7, XREF_O)
     XREF_OBJ ("Collection", collection, OT_DICTIONARY, 1, 7, XREF_O)
     XREF_BOOL ("NeedsRendering", needs_rendering, 0, 1, 7, XREF_O)
XREF_DESC_END

XREF_F_DICTIONARY (field, field_desc, 1, 0)
