/*
 * PDFlow -- colour.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef GC_STUB
XREF_DESC_BEGIN (gc_stub_field_desc, NULL)
     COBJ_ENUM ("1-ColourSpace", type, cspace_desc, 1, 0, XREF_M)
XREF_DESC_END
XREF_F_S_ARRAY (gc_stub_field, gc_stub_field_desc, 1, 0)
#undef GC_STUB
#endif

#ifdef GC_COLOUR_SPACE
XREF_DESC_BEGIN (gc_cspace_field_desc, NULL)
     COBJ_ENUM ("1-ColourSpace", type, cspace_desc, 1, 0, XREF_M)
     XREF_DYN (union gc_cspace_data, d, dyn_ifc)
XREF_DESC_END
XREF_F_S_ARRAY (gc_cspace_field, gc_cspace_field_desc, 1, 0)
#undef GC_COLOUR_SPACE
#endif

#ifdef GC_D_CAL_GRAY
GC_F_CAL_GRAY (gc_d_cal_gray_field, 1, 1)
#undef GC_D_CAL_GRAY
#endif

#ifdef GC_D_CAL_RGB
GC_F_CAL_RGB (gc_d_cal_rgb_field, 1, 1)
#undef GC_D_CAL_RGB
#endif

#ifdef GC_D_LAB
GC_F_LAB (gc_d_lab_field, 1, 1)
#undef GC_D_LAB
#endif

#ifdef GC_D_ICC_BASED
GC_F_ICC_BASED (gc_d_icc_based_field, 1, 1)
#undef GC_D_ICC_BASED
#endif

#ifdef GC_D_PATTERN
XREF_DESC_BEGIN (gc_d_pattern_field_desc, NULL)
     XREF_TAG ("1-ColourSpace", "Pattern", 1, 0, XREF_M)
     GC_CSPACE_FIELD_R ("2-BaseColourSpace", csp, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_S_ARRAY (gc_d_pattern_field, gc_d_pattern_field_desc, 1, 2)
#undef GC_D_PATTERN
#endif

#ifdef GC_D_INDEXED
XREF_DESC_BEGIN (gc_d_indexed_field_desc, NULL)
     XREF_TAG ("1-ColourSpace", "Indexed", 1, 0, XREF_M)
     GC_CSPACE_FIELD_R ("2-Base", csp, 1, 0, XREF_M)
     XREF_INTEGER ("3-Hival", hival, -1, 1, 0, XREF_M)
     GC_LOOKUP ("4-Lookup", lookup, XREF_M)
XREF_DESC_END
XREF_F_S_ARRAY (gc_d_indexed_field, gc_d_indexed_field_desc, 1, 1)
#undef GC_D_INDEXED
#endif

#ifdef GC_D_SEPARATION
XREF_DESC_BEGIN (gc_d_separation_field_desc, NULL)
     XREF_TAG ("1-ColourSpace", "Separation", 1, 0, XREF_M)
     XREF_OBJ ("2-Name", name, OT_NAME, 1, 0, XREF_M)
     GC_CSPACE_FIELD_R ("3-AlternateSpace", alternate_space, 1, 0, XREF_M)
     FUN_FUNCTION_R ("4-TintTransform", tint_transform, 1, 0, XREF_M)
XREF_DESC_END
#undef GC_D_SEPARATION
XREF_F_S_ARRAY (gc_d_separation_field, gc_d_separation_field_desc, 1, 2)
#endif     

#ifdef GC_D_DEVICE_N
GC_F_DEVICE_N (gc_d_device_n_field, 1, 3)
#undef GC_D_DEVICE_N
#endif
