/*
 * PDFlow -- filespec.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef FSPEC_DICTIONARY
XREF_DESC_BEGIN(fspec_dictionary_field_desc, NULL)
     XREF_TAG ("Type", "Filespec", 1, 0, XREF_O)
     COBJ_ENUM ("FS", fs, &fs_desc, 1, 0, XREF_O)
     XREF_OBJ ("F", f, OT_STRING, 1, 0, XREF_O)
     TS_FIELD_I ("UF", uf, 1, 7, XREF_O)
     XREF_OBJ ("DOS", dos, OT_STRING, 1, 0, XREF_O)
     XREF_OBJ ("Mac", mac, OT_STRING, 1, 0, XREF_O)
     XREF_OBJ ("Unix", un_x, OT_STRING, 1, 0, XREF_O)
     XREF_OBJ ("ID", id, OT_STRING, 1, 0, XREF_O)
     XREF_BOOL ("V", v, 0, 1, 2, XREF_O)
     XREF_NEST ("EF", struct fspec_ef, ef, OT_DICTIONARY,
		&fspec_ef_field_desc, 1, 3, XREF_O)
     XREF_NEST ("RF", struct fspec_rf, rf, OT_DICTIONARY,
		&fspec_rf_field_desc, 1, 3, XREF_O)
     TS_FIELD_I ("Desc", desc, 1, 6, XREF_O)
     XREF_OBJ ("CI", ci, OT_DICTIONARY, 1, 7, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (fspec_dictionary_field, fspec_dictionary_field_desc, 1, 1)
#undef FSPEC_DICTIONARY
#endif

#ifdef FSPEC_STRING
XREF_F_FUNCTION (fspec_string_field, fspec_string_pstable, 1, 1)
#undef FSPEC_STRING
#endif

#ifdef FSPEC_ROOT
XREF_F_DYN (fspec_root, dyn_ifc, 1, 0)
#undef FSPEC_ROOT
#endif

#ifdef FSPEC_EF
XREF_DESC_BEGIN (fspec_ef_field_desc, NULL)
     XREF_NEST ("UF", struct fspec_embedded, uf, OT_STREAM,
		&fspec_embedded_field_desc, 1, 0, XREF_O)
     XREF_NEST ("F", struct fspec_embedded, f, OT_STREAM,
		&fspec_embedded_field_desc, 1, 0, XREF_O)
     XREF_NEST ("Dos", struct fspec_embedded, dos, OT_STREAM,
		&fspec_embedded_field_desc, 1, 0, XREF_O)
     XREF_NEST ("Mac", struct fspec_embedded, mac, OT_STREAM,
		&fspec_embedded_field_desc, 1, 0, XREF_O)
     XREF_NEST ("Unix", struct fspec_embedded, un_x, OT_STREAM,
		&fspec_embedded_field_desc, 1, 0, XREF_O)
XREF_DESC_END
#undef FSPEC_EF
#endif

#ifdef FSPEC_RF
XREF_DESC_BEGIN (fspec_rf_field_desc, NULL)
     XREF_A_ARRAY ("UF", struct xref_obj_array, uf, 
		   &xref_obj_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("F", struct xref_obj_array, f, 
		   &xref_obj_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("Dos", struct xref_obj_array, dos, 
		   &xref_obj_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("Max", struct xref_obj_array, mac, 
		   &xref_obj_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("Unix", struct xref_obj_array, un_x, 
		   &xref_obj_pstable, 1, 0, XREF_O)
XREF_DESC_END
#undef FSPEC_RF
#endif

#ifdef FSPEC_EMBEDDED
XREF_DESC_BEGIN (fspec_embedded_field_desc, NULL)
     XREF_TAG ("Type", "EmbeddedFile", 1, 0, XREF_O)
     XREF_OBJ ("Subtype", subtype, OT_NAME, 1, 0, XREF_O)
     XREF_NEST ("Params", struct fspec_params, params, OT_DICTIONARY,
		&fspec_params_field_desc, 1, 0, XREF_O)
     XREF_REGION (contents)
XREF_DESC_END
#undef FSPEC_EMBEDDED
#endif

#ifdef FSPEC_PARAMS
XREF_DESC_BEGIN  (fspec_params_field_desc, NULL)
     XREF_INTEGER ("Size", size, -1, 1, 0, XREF_O)
     COBJ_DATE ("CreationDate", creation_date, 1, 0, XREF_O)
     COBJ_DATE ("ModDate", mod_date, 1, 0, XREF_O)
     XREF_NEST ("Mac", struct fspec_mac, mac, OT_DICTIONARY,
		&fspec_mac_field_desc, 1, 0, XREF_O)
     XREF_OBJ ("Checksum", checksum, OT_NAME, 1, 0, XREF_O)
XREF_DESC_END
#undef FSPEC_PARAMS
#endif

#ifdef FSPEC_MAC
XREF_DESC_BEGIN (fspec_mac_field_desc, NULL)
     XREF_INTEGER ("Subtype", subtype, -1, 1, 0, XREF_O)
     XREF_INTEGER ("Creator", creator, -1, 1, 0, XREF_O)
     XREF_OBJ ("ResFork", res_fork, OT_STREAM, 1, 0, XREF_O)
XREF_DESC_END
#undef FSPEC_MAC
#endif
