/*
 * PDFlow -- font.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef GF_FONT
XREF_DESC_BEGIN (gf_font_field_desc, NULL)
     XREF_TAG ("Type", "Font", 1, 0, XREF_M)
     COBJ_ENUM ("Subtype", subtype, &subtype_desc, 1, 0, XREF_M)
     XREF_DYN (union gf_data, u, dyn_ifc)
XREF_DESC_END
XREF_F_DICTIONARY (gf_font_field, gf_font_field_desc, 1, 0)
#undef GF_FONT
#endif

#ifdef GF_ENCODING
XREF_DESC_BEGIN (gf_encoding_field_desc, NULL)
     XREF_TAG ("Type", "Encoding", 1, 0, XREF_M)
     COBJ_ENUM ("BaseEncoding", base_encoding, &encoding_desc, 1, 0, XREF_O)
     XREF_A_ARRAY ("Differences", struct xref_obj_array, differences,
		   &xref_obj_pstable, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (gf_encoding_field, gf_encoding_field_desc, 1, 0)
#undef GF_ENCODING
#endif

#ifdef GF_SIMPLE_FONT
XREF_DESC_BEGIN (gf_simple_font_field_desc, NULL)
     XREF_OBJ ("Name", name, OT_NAME, 1, 0, XREF_O)
     XREF_OBJ ("BaseFont", base_font, OT_NAME, 1, 0, XREF_M)
     XREF_INTEGER ("FirstChar", first_char, -1, 1, 0, XREF_O)
     XREF_INTEGER ("LastChar", last_char, -1, 1, 0, XREF_O)
     XREF_A_ARRAY ("Widths", struct xref_real_array, widths,
		   &xref_real_pstable, 1, 0, XREF_O)
     GF_FONT_DESC_R ("FontDescriptor", font_descriptor, 1, 0, XREF_O)
     GF_ENCODING_ENUM ("Encoding", encoding, &encoding_desc, 1, 0, XREF_O)
     XREF_OBJ ("ToUnicode", to_unicode, OT_STREAM, 1, 2, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (gf_simple_font_field, gf_simple_font_field_desc, 1, 0)
#undef GF_SIMPLE_FONT
#endif

#ifdef GF_TYPE0_FONT
XREF_DESC_BEGIN (gf_type0_font_field_desc, NULL)
     XREF_OBJ ("BaseFont", base_font, OT_NAME, 1, 0, XREF_M)
     XREF_OBJ ("Encoding", encoding, OT_ANY, 1, 0, XREF_M)
     XREF_A_ARRAY ("DescendantFonts", struct gf_font_array, 
		   descendant_fonts, &gf_pstable, 1, 0, XREF_M)
     XREF_OBJ ("ToUnicode", to_unicode, OT_STREAM, 1, 2, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (gf_type0_font_field, gf_type0_font_field_desc, 1, 2)
#undef GF_TYPE0_FONT
#endif

#ifdef GF_TYPE3_FONT
XREF_DESC_BEGIN (gf_type3_font_field_desc, NULL)
     XREF_OBJ ("Name", name, OT_NAME, 1, 0, XREF_O)
     COBJ_RECT ("FontBBox", font_bbox, 1, 0, XREF_M)
     COBJ_MATRIX ("FontMatrix", font_matrix, 1, 0, XREF_M)
     XREF_OBJ ("CharProcs", char_procs, OT_DICTIONARY, 1, 0, XREF_M)
     GF_ENCODING_ENUM ("Encoding", encoding, &encoding_desc, 1, 0, XREF_O)
     XREF_INTEGER ("FirstChar", first_char, -1, 1, 0, XREF_M)
     XREF_INTEGER ("LastChar", last_char, -1, 1, 0, XREF_M)
     XREF_A_ARRAY ("Widths", struct xref_real_array, widths,
		   &xref_real_pstable, 1, 0, XREF_M)
     GF_FONT_DESC_R ("FontDescriptor", font_descriptor, 1, 0, XREF_O)
     RD_FIELD_R ("Resources", resources, 1, 2, XREF_O)
     XREF_OBJ ("ToUnicode", to_unicode, OT_STREAM, 1, 2, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (gf_type3_font_field, gf_type3_font_field_desc, 1, 0)
#undef GF_TYPE3_FONT
#endif

#ifdef GF_CID_FONT
XREF_DESC_BEGIN (gf_cid_font_field_desc, NULL)
     XREF_OBJ ("BaseFont", base_font, OT_NAME, 1, 0, XREF_M)
     XREF_OBJ ("CIDSystemInfo", cid_systeminfo, OT_DICTIONARY, 1, 0, XREF_M)
     GF_FONT_DESC_R ("FontDescriptor", font_descriptor, 1, 0, XREF_M)
     XREF_INTEGER ("DW", dw, 1000, 1, 0, XREF_O)
     XREF_A_ARRAY ("W", struct xref_obj_array, w,
		   &xref_obj_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("DW2", struct xref_real_array, dw2,
		   &xref_real_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("W2", struct xref_obj_array, w2,
		   &xref_obj_pstable, 1, 0, XREF_O)
     COBJ_ENUM_OBJ ("CIDToGIDMap", cid_to_gid_map, &cid_to_gid_map_desc,
		    1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (gf_cid_font_field, gf_cid_font_field_desc, 1, 0)
#undef GF_CID_FONT
#endif

#ifdef GF_FONT_DESC
XREF_DESC_BEGIN (gf_font_desc_field_desc, NULL)
     XREF_TAG ("Type", "FontDescriptor", 1, 0, XREF_O)
     XREF_OBJ ("FontName", font_name, OT_NAME, 1, 0, XREF_O)
     XREF_OBJ ("FontFamily", font_family, OT_STRING, 1, 5, XREF_O)
     XREF_OBJ ("FontStretch", font_stretch, OT_NAME, 1, 5, XREF_O)
     XREF_REAL ("FontWeight", font_weight, 400, 1, 5, XREF_O)
     XREF_INTEGER ("Flags", flags, 0, 1, 0, XREF_M)
     COBJ_RECT ("FontBBox", font_bbox, 1, 0, XREF_M)
     XREF_REAL ("ItalicAngle", italic_angle, 0, 1, 0, XREF_M)
     XREF_REAL ("Ascent", ascent, 0, 1, 0, XREF_O)
     XREF_REAL ("Descent", descent, 0, 1, 0, XREF_O)
     XREF_REAL ("Leading", leading, 0, 1, 0, XREF_O)
     XREF_REAL ("CapHeight", cap_height, 0, 1, 0, XREF_O)
     XREF_REAL ("XHeight", x_height, 0, 1, 0, XREF_O)
     XREF_REAL ("StemV", stem_v, 0, 1, 0, XREF_O)
     XREF_REAL ("StemH", stem_h, 0, 1, 0, XREF_O)
     XREF_REAL ("AvgWidth", avg_width, 0, 1, 0, XREF_O)
     XREF_REAL ("MaxWidth", max_width, 0, 1, 0, XREF_O)
     XREF_REAL ("MissingWidth", missing_width, 0, 1, 0, XREF_O)
     XREF_OBJ ("FontFile", font_file, OT_STREAM, 1, 0, XREF_O)
     XREF_OBJ ("FontFile2", font_file2, OT_STREAM, 1, 0, XREF_O)
     XREF_OBJ ("FontFile3", font_file3, OT_STREAM, 1, 0, XREF_O)
     XREF_OBJ ("CharSet", char_set, OT_STRING, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (gf_font_desc_field, gf_font_desc_field_desc, 1, 0)
#undef GF_FONT_DESC
#endif
