/*
 * PDFlow -- function.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef FUN_FUNCTION
XREF_DESC_BEGIN (fun_function_field_desc, NULL)
     XREF_INTEGER ("FunctionType", function_type, -1, 1, 0, XREF_M)
     FUN_REGION ("Domain", domain, 1, 0, XREF_M)
     FUN_REGION ("Range", range, 1, 0, XREF_O)
     XREF_DYN (union fun_data, u, dyn_ifc)
XREF_DESC_END
XREF_F_DICTIONARY (fun_function_field, fun_function_field_desc, 1, 0)
#undef FUN_FUNCTION
#endif

#ifdef FUN_SAMPLED
XREF_DESC_BEGIN (fun_sampled_field_desc, NULL)
     XREF_A_ARRAY ("Size", struct xref_int_array,
		   size, &xref_int_pstable, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerSample", bits_per_sample, 0, 1, 0, XREF_M)
     XREF_INTEGER ("Order", order, 1, 1, 0, XREF_O)
     FUN_REGION ("Encode", encode, 1, 2, XREF_O)
     FUN_REGION ("Decode", decode, 1, 2, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (fun_sampled_field, fun_sampled_field_desc, 1, 2)
#undef FUN_SAMPLED
#endif

#ifdef FUN_EXPONENTIAL
XREF_DESC_BEGIN (fun_exponential_field_desc, NULL)
     XREF_A_ARRAY ("C0", struct xref_real_array, 
		   c0, &xref_real_pstable, 1, 0, XREF_O) 
     XREF_A_ARRAY ("C1", struct xref_real_array, 
		   c1, &xref_real_pstable, 1, 0, XREF_O)
     XREF_INTEGER ("N", n, 0, 1, 1, XREF_M)
XREF_DESC_END
XREF_F_DICTIONARY (fun_exponential_field, fun_exponential_field_desc, 1, 3)
#undef FUN_EXPONENTIAL
#endif

#ifdef FUN_STITCHING
XREF_DESC_BEGIN (fun_stitching_field_desc, NULL)
     XREF_A_ARRAY ("Functions", struct fun_array, 
		   functions, &fun_pstable, 1, 0, XREF_M)
     XREF_A_ARRAY ("Bounds", struct xref_real_array, 
		   bounds, &xref_real_pstable, 1, 0, XREF_M)
     FUN_REGION ("Encode", encode, 1, 3, XREF_M)
XREF_DESC_END
XREF_F_DICTIONARY (fun_stitching_field, fun_stitching_field_desc, 1, 3)
#undef FUN_STITCHING
#endif

#ifdef FUN_POSTSCRIPT
XREF_DESC_BEGIN (fun_postscript_field_desc, NULL)
XREF_DESC_END
XREF_F_STREAM (fun_postscript_field, fun_postscript_field_desc, 1, 3)
#undef FUN_POSCRIPT
#endif
