/*
 * PDFlow -- info.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef info_h

#define info_h

#include "hash.h"
#include "fmt/objbr.h"
#include "types/types.h"
#include "types/txtstring.h"
#include "types/cobj.h"

enum info_trapped {

	INFO_T_TRUE,
	INFO_T_FALSE,
	INFO_T_UNKNOWN

};

struct info {

	struct t_type t;

#include "info.tab.h"	

};

T_PROTOTYPES (info, info);

#define INFO_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct info, field, \
                 &info_pstable, major, minor, mand)

enum s_status info_touch (struct info *info);
enum s_status info_update (struct info *info, struct hash_status *hs);

#endif
