/*
 * PDFlow -- oc.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef oc_h

#define oc_h

#include "refs.h"
#include "fmt/fields.h"
#include "types/types.h"
#include "types/txtstring.h"

extern const char *oc_properties_bkey;

struct oc_group_list_entry_array {
	size_t n;
	struct oc_group_list_entry *data;
};

extern struct xref_pstable oc_group_list_entry_pstable;
extern struct xref_pstable oc_reference_pstable;
extern struct xref_pstable oc_ve_pstable;

T_PROTOTYPES (oc_group, oc_group);
T_PROTOTYPES (oc_directory, oc_directory);
T_PROTOTYPES (oc_config, oc_config);
T_PROTOTYPES (oc_properties, oc_properties);
T_PROTOTYPES (oc_app_dir, oc_app_dir);
T_PROTOTYPES (oc_u_creator_info, oc_u_creator_info);
T_PROTOTYPES (oc_u_language, oc_u_language);
T_PROTOTYPES (oc_u_export, oc_u_export);
T_PROTOTYPES (oc_u_zoom, oc_u_zoom);
T_PROTOTYPES (oc_u_print, oc_u_print);
T_PROTOTYPES (oc_u_view, oc_u_view);
T_PROTOTYPES (oc_u_user, oc_u_user);
T_PROTOTYPES (oc_u_page_element, oc_u_page_element);
T_PROTOTYPES (oc_usage, oc_usage);

#define OC_PROPERTIES_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct oc_properties, field, \
                 &oc_properties_pstable, major, minor, mand)
#define OC_GROUP_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct oc_group, field, \
                 &oc_group_pstable, major, minor, mand)
#define OC_GROUP_A_ARRAY(name, field, major, minor, mand) \
XREF_A_ARRAY (name, struct oc_group, field, \
              &oc_group_pstable, major, minor, mand)

#define OC_GROUP_LIST_ENTRY_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_group_list_entry, field, \
                 &oc_group_list_entry_pstable, major, minor, mand)

#define OC_REFERENCE_FIELD_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_reference, field,	      \
		 &oc_reference_pstable, major, minor, mand)

#define OC_VE_FIELD_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_ve, field,	      \
		 &oc_ve_pstable, major, minor, mand)

#define OC_CONFIG_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct oc_config, field, \
                 &oc_config_pstable, major, minor, mand)

#define OC_CONFIG_A_ARRAY(name, field, major, minor, mand) \
XREF_A_ARRAY (name, struct oc_config_array, field, \
              &oc_config_pstable, major, minor, mand)

#define OC_USAGE_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct oc_usage, field, \
                 &oc_usage_pstable, major, minor, mand)

#define OC_APP_DIR_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct oc_app_dir, field, \
                 &oc_app_dir_pstable, major, minor, mand)
#define OC_GROUP_APP_DIR_A_ARRAY(name, field, major, minor, mand) \
XREF_A_ARRAY (name, struct oc_app_dir_array, field, \
              &oc_app_dir_pstable, major, minor, mand)

#define OC_U_CREATOR_INFO_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_u_creator_info, field, \
                 &oc_u_creator_info_pstable, major, minor, mand)
#define OC_U_LANGUAGE_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_u_language, field, \
                 &oc_u_language_pstable, major, minor, mand)
#define OC_U_EXPORT_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_u_export, field, \
                 &oc_u_export_pstable, major, minor, mand)
#define OC_U_ZOOM_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_u_zoom, field, \
                 &oc_u_zoom_pstable, major, minor, mand)
#define OC_U_PRINT_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_u_print, field, \
                 &oc_u_print_pstable, major, minor, mand)
#define OC_U_VIEW_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_u_view, field, \
                 &oc_u_view_pstable, major, minor, mand)
#define OC_U_USER_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_u_user, field, \
                 &oc_u_user_pstable, major, minor, mand)
#define OC_U_PAGE_ELEMENT_I(name, field, major, minor, mand) \
XREF_FUNCTION_I (name, struct oc_u_page_element, field, \
                 &oc_u_page_element_pstable, major, minor, mand)

#define OC_APP_DIR_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct oc_app_dir, field, \
                 &oc_app_dir_pstable, major, minor, mand)

enum oc_cfg_base_state {

	OC_CFG_BS_ON,
	OC_CFG_BS_OFF,
	OC_CFG_BS_UNCHANGED

};

enum oc_state {

	OC_S_ON,
	OC_S_OFF

};

enum oc_intent {

	OC_I_VIEW,
	OC_I_DESIGN,
	OC_I_OTHER
};

enum oc_usage_utype {

	OC_U_UT_INDIVIDUAL,
	OC_U_UT_TITLE,
	OC_U_UT_ORGANIZATION
};

enum oc_usage_petype {

	OC_U_PET_HEADER_FOOTER,
	OC_U_PET_FOREGROUND,
	OC_U_PET_BACKGROUND,
	OC_U_PET_LOGO
};

enum oc_app_event_type {
	OC_ET_VIEW,
	OC_ET_PRINT,
	OC_ET_EXPORT
};

enum oc_group_list_entry_type {

	OC_GL_ET_UNRESOLVED = 0,
	OC_GL_ET_TAG,
	OC_GL_ET_GROUP,
	OC_GL_ET_GROUP_LIST

};

enum oc_list_mode {

	OC_LM_ALL_PAGES,
	OC_LM_VISIBLE_PAGES
};

enum oc_ref_type {

	OC_RT_NONE,
	OC_RT_UNRESOLVED,
	OC_RT_GROUP,
	OC_RT_DIRECTORY

};

enum oc_ve_entry_type {

	OC_VT_UNRESOLVED,
	OC_VT_GROUP,
	OC_VT_VE

};

enum oc_directory_policy {

	OC_DP_ALL_ON,
	OC_DP_ANY_ON,
	OC_DP_ANY_OFF,
	OC_DP_ALL_OFF

};

enum oc_directory_op {

	OC_DO_NOT,
	OC_DO_AND,
	OC_DO_OR

};

struct oc_u_creator_info {

	struct t_type t;

#define OC_U_CREATOR_INFO
#include "types/oc.tab.h"	
} creator_info;

struct oc_u_language {

	struct t_type t;

#define OC_U_LANGUAGE
#include "types/oc.tab.h"	
};

struct oc_u_export {

	struct t_type t;
	
#define OC_U_EXPORT
#include "types/oc.tab.h"	
};

struct oc_u_zoom {

	struct t_type t;

#define OC_U_ZOOM
#include "types/oc.tab.h"	
};

struct oc_u_print {

	struct t_type t;

#define OC_U_PRINT
#include "types/oc.tab.h"	
};

struct oc_u_view {

	struct t_type t;

#define OC_U_VIEW
#include "types/oc.tab.h"	
};

struct oc_u_user {

	struct t_type t;

#define OC_U_USER
#include "types/oc.tab.h"	
};

struct oc_u_page_element {

	struct t_type t;

#define OC_U_PAGE_ELEMENT
#include "types/oc.tab.h"	
};

struct oc_usage {
	
	struct t_type t;

#define OC_USAGE
#include "types/oc.tab.h"
};

struct oc_group {

	struct t_type t;


#define OC_GROUP
#include "types/oc.tab.h"

};

struct oc_reference {

	enum oc_ref_type type;

	union {
		struct oc_group *group;
		struct oc_directory *directory;
	} u;

};

union oc_group_list_entry_data {
	struct ts_string tag;
	struct oc_group_list_entry_array list;
	struct oc_group *group;
	struct obj_reference ref;
};

struct oc_group_list_entry {
	
	enum oc_group_list_entry_type type;

	union oc_group_list_entry_data u;
};

struct oc_app_dir {

	struct t_type t;

#define OC_APP_DIR
#include "types/oc.tab.h"	
	
};

struct oc_ve {

	int negated;

	enum oc_directory_op op;

	int entries;
	struct oc_ve_entry {
		enum oc_ve_entry_type type;

		union {
			struct oc_group *group;
			struct oc_ve *ve;
		} u;
	} *entry;
};

struct oc_directory {

	struct t_type t;

	struct oc_directory *next;

#define OC_DIRECTORY
#include "oc.tab.h"

};

struct oc_config {

	struct t_type t;

#define OC_CONFIG
#include "oc.tab.h"
};

struct oc_properties {
	
	struct t_type t;

	struct oc_group_array groups;
	
	struct oc_directory *directory;

#define OC_PROPERTIES
#include "types/oc.tab.h"
};

#endif


