/*
 * PDFlow -- oc.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef OC_GROUP
XREF_DESC_BEGIN (oc_group_field_desc, NULL)
     XREF_TAG ("Type", "OCG", 1, 0, XREF_M)
     TS_FIELD_I ("Name", name, 1, 0, XREF_M)
     COBJ_ENUM_S_ARRAY ("Intent", intent, intent_desc, 1, 0, XREF_O)
     OC_USAGE_R ("Usage", usage, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_group_field, oc_group_field_desc, 1, 5)
#undef OC_GROUP
#endif

#ifdef OC_DIRECTORY
XREF_DESC_BEGIN (oc_directory_field_desc, NULL)
     XREF_TAG ("Type", "OCMD", 1, 0, XREF_M)
     XREF_S_ARRAY ("OCGs", struct oc_group_array, ocgs,
		   &oc_group_list_entry_pstable, 1, 0, XREF_O)
     COBJ_ENUM ("P", p, p_desc, 1, 0, XREF_O)
     OC_VE_FIELD_I ("VE", ve, 1, 6, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_directory_field, oc_directory_field_desc, 1, 5)
#undef OC_DIRECTORY
#endif

#ifdef OC_PROPERTIES
XREF_DESC_BEGIN (oc_properties_field_desc, NULL)
     OC_GROUP_A_ARRAY ("OCGs", ocgs, 1, 0, XREF_M)
     OC_CONFIG_R ("D", d, 1, 0, XREF_O)
     OC_CONFIG_A_ARRAY ("Configs", configs, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_properties_field, oc_properties_field_desc, 1, 5)
#undef OC_PROPERTIES
#endif

#ifdef OC_CONFIG
XREF_DESC_BEGIN (oc_config_field_desc, NULL)
     TS_FIELD_I ("Name", name, 1, 0, XREF_O)
     TS_FIELD_I ("Creator", creator, 1, 0, XREF_O)
     COBJ_ENUM ("BaseState", base_state, base_state_desc, 1, 0, XREF_O)
     OC_GROUP_A_ARRAY ("ON", on, 1, 0, XREF_O)
     OC_GROUP_A_ARRAY ("OFF", off, 1, 0, XREF_O)
     COBJ_ENUM_S_ARRAY ("Intent", intent, intent_desc, 1, 0, XREF_O)
     OC_GROUP_APP_DIR_A_ARRAY ("AS", as, 1, 0, XREF_O)
     OC_GROUP_A_ARRAY ("Order", order, 1, 0, XREF_O)
     COBJ_ENUM ("ListMode", list_mode, list_mode_desc, 1, 0, XREF_O)
     OC_GROUP_A_ARRAY ("RBGroups", rb_groups, 1, 0, XREF_O)
     OC_GROUP_A_ARRAY ("Locked", locked, 1, 6, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_config_field, oc_config_field_desc, 1, 5)
#undef OC_CONFIG
#endif

#ifdef OC_U_CREATOR_INFO
XREF_DESC_BEGIN (oc_u_creator_info_field_desc, NULL)
     TS_FIELD_I ("Creator", creator, 1, 0, XREF_M)
     /* Should have been mandatory but some creators don't set it */
     XREF_OBJ ("Subtype", subtype, OT_NAME, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_u_creator_info_field, oc_u_creator_info_field_desc, 1, 5)
#undef OC_U_CREATOR_INFO
#endif

#ifdef OC_U_LANGUAGE
XREF_DESC_BEGIN (oc_u_language_field_desc, NULL)
     TS_FIELD_I ("Lang", creator, 1, 0, XREF_M)
     COBJ_ENUM ("Preferred", preferred, state_desc, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_u_language_field, oc_u_language_field_desc, 1, 5)
#undef OC_U_LANGUAGE
#endif

#ifdef OC_U_EXPORT
XREF_DESC_BEGIN (oc_u_export_field_desc, NULL)
     COBJ_ENUM ("Export", export, state_desc, 1, 0, XREF_M)
XREF_DESC_END
XREF_F_DICTIONARY (oc_u_export_field, oc_u_export_field_desc, 1, 5)
#undef OC_U_EXPORT
#endif

#ifdef OC_U_ZOOM
XREF_DESC_BEGIN (oc_u_zoom_field_desc, NULL)
     XREF_REAL ("min", min_value, 0, 1, 0, XREF_O)
     XREF_REAL ("max", max_value, -1, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_u_zoom_field, oc_u_zoom_field_desc, 1, 5)
#undef OC_U_ZOOM
#endif

#ifdef OC_U_PRINT
XREF_DESC_BEGIN (oc_u_print_field_desc, NULL)
     XREF_OBJ ("Subtype", subtype, OT_NAME, 1, 0, XREF_O)
     COBJ_ENUM ("PrintState", print_state, state_desc, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_u_print_field, oc_u_print_field_desc, 1, 5)
#undef OC_U_PRINT
#endif

#ifdef OC_U_VIEW
XREF_DESC_BEGIN (oc_u_view_field_desc, NULL)
     COBJ_ENUM ("ViewState", view_state, state_desc, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_u_view_field, oc_u_view_field_desc, 1, 5)
#undef OC_U_VIEW
#endif

#ifdef OC_U_USER
XREF_DESC_BEGIN (oc_u_user_field_desc, NULL)
     COBJ_ENUM ("Type", type, utype_desc, 1, 0, XREF_M)
     TS_FIELD_S_ARRAY ("Name", name, 1, 0, XREF_M)
XREF_DESC_END
#undef OC_U_USER
XREF_F_DICTIONARY (oc_u_user_field, oc_u_user_field_desc, 1, 5)
#endif

#ifdef OC_U_PAGE_ELEMENT
XREF_DESC_BEGIN (oc_u_page_element_field_desc, NULL)
     /* Ok, the same implementation sets 'SubType' instead of 'Subtype' 
      * Forget about it, I won't change the definition, just set optional*/
     COBJ_ENUM ("Subtype", type, petype_desc, 1, 0, XREF_O)
XREF_DESC_END
#undef OC_U_PAGE_ELEMENT
XREF_F_DICTIONARY (oc_u_page_element_field, oc_u_page_element_field_desc, 1, 5)
#endif

#ifdef OC_USAGE
XREF_DESC_BEGIN (oc_usage_field_desc, NULL)
     OC_U_CREATOR_INFO_I ("CreatorInfo", creator_info, 1, 0, XREF_O)
     OC_U_LANGUAGE_I ("Language", language, 1, 0, XREF_O)
     OC_U_EXPORT_I ("Export", export, 1, 0, XREF_O)
     OC_U_ZOOM_I ("Zoom", zoom, 1, 0, XREF_O)
     OC_U_PRINT_I ("Print", print, 1, 0, XREF_O)
     OC_U_VIEW_I ("View", view, 1, 0, XREF_O)
     OC_U_USER_I ("User", user, 1, 0, XREF_O)
     OC_U_PAGE_ELEMENT_I ("PageElement", page_element, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (oc_usage_field, oc_usage_field_desc, 1, 5)
#undef OC_USAGE
#endif

#ifdef OC_APP_DIR
XREF_DESC_BEGIN (oc_app_dir_field_desc, NULL)
     COBJ_ENUM_S_ARRAY ("Event", event, event_desc, 1, 0, XREF_M)
     XREF_A_ARRAY ("OCGs", struct oc_group_list_entry, ocgs,
		   &oc_group_list_entry_pstable, 1, 0, XREF_O)
     XREF_OBJ ("Category", category, OT_NAME, 1, 0, XREF_M)
XREF_DESC_END
XREF_F_DICTIONARY (oc_app_dir_field, oc_app_dir_field_desc, 1, 5)
#undef OC_APP_DIR
#endif
