/*
 * PDFlow -- page.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef PG_INHERITABLE
XREF_DESC_BEGIN (inh_field_desc, NULL)
     RD_FIELD_R ("Resources", resources, 1, 0, XREF_O)
     COBJ_RECT ("MediaBox", media_box, 1, 0, XREF_O)
     COBJ_RECT ("CropBox", crop_box, 1, 0, XREF_O)
     XREF_OBJ ("Rotate", rotate, OT_INTEGER, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (inh_field, inh_field_desc, 1, 0)
#undef PG_INHERITABLE
#endif

#ifdef PG_NODE
XREF_DESC_BEGIN (node_field_desc, NULL)
     XREF_TAG ("Type", "Pages", 1, 0, XREF_M)
     XREF_INLINE ("Parent", parent, OT_DICTIONARY, 1, 0, XREF_O)
     XREF_A_ARRAY ("Kids", struct xref_obj_array, kids, 
		   &xref_dictionary_pstable, 1, 0, XREF_M)
     XREF_INTEGER ("Count", count, 0, 1, 0, XREF_M)
     XREF_INCLUDE (struct pg_inheritable, sinh, OT_DICTIONARY, &inh_field_desc)
XREF_DESC_END
XREF_F_DICTIONARY (node_field, node_field_desc, 1, 0)
#undef PG_NODE
#endif

#ifdef PG_PAGE
XREF_DESC_BEGIN (page_field_desc, NULL)
     XREF_TAG ("Type", "Page", 1, 0, XREF_M)
     XREF_INLINE ("Parent", parent, OT_DICTIONARY, 1, 0, XREF_M)
     COBJ_DATE ("LastModified", last_modified, 1, 3, XREF_O)
     COBJ_RECT ("BleedBox", bleed_box, 1, 3, XREF_O)
     COBJ_RECT ("TrimBox", trim_box, 1, 3, XREF_O)
     COBJ_RECT ("ArtBox", art_box, 1, 3, XREF_O)
     XREF_OBJ ("BoxColorInfo", box_color_info, OT_DICTIONARY, 1, 4, XREF_O)
     XREF_S_ARRAY ("Contents", struct xref_obj_array, contents, 
		   &xref_stream_pstable, 1, 0, XREF_O)
     XREF_OBJ ("Group", group, OT_DICTIONARY, 1, 4, XREF_O)
     XREF_OBJ ("Thumb", thumb, OT_STREAM, 1, 0, XREF_O)
     XREF_OBJ ("B", b, OT_ARRAY, 1, 1, XREF_O)
     XREF_INTEGER ("Dur", dur, -1, 1, 1, XREF_O)
     XREF_OBJ ("Trans", trans, OT_DICTIONARY, 1, 1, XREF_O)
     XREF_OBJ ("Annots", annots, OT_ARRAY, 1, 0, XREF_O)
     XREF_OBJ ("AA", aa, OT_DICTIONARY, 1, 2, XREF_O)
     XREF_OBJ ("Metadata", metadata, OT_STREAM, 1, 4, XREF_O)
     XREF_OBJ ("PieceInfo", piece_info, OT_DICTIONARY, 1, 3, XREF_O)
     XREF_INTEGER ("StructParents", struct_parents, -1, 1, 3, XREF_O)
     XREF_OBJ ("ID", id, OT_STRING, 1, 3, XREF_O)
     XREF_INTEGER ("PZ", pz, -1, 1, 3, XREF_O)
     XREF_OBJ ("SeparationInfo", separation_info, OT_DICTIONARY, 1, 3, XREF_O)
     XREF_OBJ ("Tabs", tabs, OT_NAME, 1, 5, XREF_O)
     XREF_OBJ ("TemplateInstantiated", 
	       template_instantiated, OT_NAME, 1, 5, XREF_O)
     XREF_OBJ ("PresSteps", pres_steps, OT_DICTIONARY, 1, 5, XREF_O)
     XREF_INTEGER ("UserUnit", user_unit, 1, 1, 6, XREF_O)
     XREF_OBJ ("VP", vp, OT_DICTIONARY, 1, 6, XREF_O)
     XREF_INCLUDE (struct pg_inheritable, sinh, OT_DICTIONARY, &inh_field_desc)
XREF_DESC_END
XREF_F_DICTIONARY (page_field, page_field_desc, 1, 0)
#undef PG_PAGE
#endif

