/*
 * PDFlow -- pattern.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef pattern_h

#define pattern_h

#include "refs.h"
#include "fmt/fields.h"
#include "types/types.h"
#include "types/cobj.h"
#include "types/shading.h"
#include "types/resdict.h"

enum pt_pattern_type {

	PT_PT_TILING = 1,
	PT_PT_SHADING = 2

};

enum pt_paint_type {
	PT_TPT_COLOURED = 1,
	PT_TPT_STENCIL = 2
};

enum pt_tiling_type {
	PT_TT_CONSTANT_SPACING = 1,
	PT_TT_NO_DISTORTION = 2,
	PT_TT_FATER_TILING = 3
};

struct pt_tiling_pattern {

#define PT_TILING
#include "types/pattern.tab.h"

};

struct pt_shading_pattern {

#define PT_SHADING
#include "types/pattern.tab.h"

};

union pt_data {
	
	struct pt_tiling_pattern tiling;
	struct pt_shading_pattern shading;

};

struct pt_pattern {

	struct t_type t;

	struct pt_pattern_ifc *ifc;

#define PT_PATTERN
#include "types/pattern.tab.h"

};

T_PROTOTYPES (pt, pt_pattern);

#endif
