/*
 * PDFlow -- pattern.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef PT_PATTERN
XREF_DESC_BEGIN (pt_pattern_field_desc, NULL)
     XREF_TAG ("Type", "Pattern", 1, 0, XREF_O)
     XREF_INTEGER ("PatternType", pattern_type, 0, 1, 0, XREF_M)
     XREF_DYN (union pt_data, u, dyn_ifc)
XREF_DESC_END
XREF_F_DICTIONARY (pt_pattern_field, pt_pattern_field_desc, 1, 0)
#undef PT_PATTERN
#endif

#ifdef PT_TILING
XREF_DESC_BEGIN (pt_tiling_field_desc, NULL)
     XREF_INTEGER ("PaintType", paint_type, 0, 1, 0, XREF_M)
     XREF_INTEGER ("TilingType", tiling_type, 0, 1, 0, XREF_M)
     COBJ_RECT ("BBox", bbox, 1, 0, XREF_M)
     XREF_REAL ("XStep", xstep, 0, 1, 0, XREF_M)
     XREF_REAL ("YStep", ystep, 0, 1, 0, XREF_M)
     RD_FIELD_R ("Resources", resources, 1, 0, XREF_M)
     COBJ_MATRIX ("Matrix", matrix, 1, 0, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (pt_tiling_field, pt_tiling_field_desc, 1, 0)
#undef PT_TILING
#endif

#ifdef PT_SHADING
XREF_DESC_BEGIN (pt_shading_field_desc, NULL)
     SHD_FIELD_R ("Shading", shading, 1, 0, XREF_M)
     COBJ_MATRIX ("Matrix", matrix, 1, 0, XREF_O)
     /* Can't use GS_FIELD_R because of mutual dependance with gstate.h */
     XREF_FUNCTION_R ("ExtGState", struct gs_state, ext_gstate,
		      &gs_pstable, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (pt_shading_field, pt_shading_field_desc, 1, 0)
#undef PT_SHADING
#endif

