/*
 * PDFlow -- resdict.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef resdict_h

#define resdict_h

#include "types/types.h"

struct gc_colour_space;
struct pt_pattern;
struct shd_shading;
struct xo_object;
struct oc_properties;
struct gf_font;

extern const char *rd_bkey;

struct rd_resdict {

	struct t_type t;

#include "resdict.tab.h"
};

T_PROTOTYPES (rd, rd_resdict);

#define RD_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct rd_resdict, field, \
                 &rd_pstable, major, minor, mand)

enum s_status rd_get_ext_g_state (struct rd_resdict *rd, struct obj *name,
				  struct obj *dict);
enum s_status rd_get_opt_cspace (struct rd_resdict *rd, const char *name,
				 struct gc_colour_space **space, 
				 struct ref_owner *p);
enum s_status rd_get_cspace (struct rd_resdict *rd, struct xref_db *rdb,
			     struct obj *name,
			     struct gc_colour_space **space, 
			     struct ref_owner *p);
enum s_status rd_get_pattern (struct rd_resdict *rd, struct obj *name,
			      struct pt_pattern **pattern, 
			      struct ref_owner *p);
enum s_status rd_get_shading (struct rd_resdict *rd, struct obj *name,
			      struct shd_shading **shd, struct ref_owner *p);
enum s_status rd_get_xobject (struct rd_resdict *rd, struct obj *name,
			      struct oc_properties *ocp,
			      struct xo_object **xo, struct ref_owner *p);
enum s_status rd_get_font (struct rd_resdict *rd, struct obj *name,
			   struct gf_font **gf, struct ref_owner *p);

enum s_status rd_lookup (struct rd_resdict *rd, struct obj *name,
			 struct obj *coll, struct obj *val, 
			 struct t_tag *tag, int *pres);
enum s_status rd_lookup_s (struct rd_resdict *rd, const char *name,
			   struct obj *coll, struct obj *val, 
			   struct t_tag *tag, int *pres);

#endif
