/*
 * PDFlow -- shading.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef SHD_SHADING
XREF_DESC_BEGIN (shd_shading_field_desc, NULL)
     XREF_INTEGER ("ShadingType", shading_type, -1, 1, 0, XREF_M)
     GC_CSPACE_FIELD_R ("ColorSpace", color_space, 1, 0, XREF_M)
     XREF_A_ARRAY ("Background", struct xref_real_array, background,
		   &xref_real_pstable, 1, 0, XREF_O)
     COBJ_RECT ("BBox", bbox, 1, 0, XREF_O)
     XREF_BOOL ("AntiAlias", anti_alias, 0, 1, 0, XREF_O)
     XREF_DYN (union shd_data, u, dyn_ifc)
XREF_DESC_END
XREF_F_DICTIONARY (shd_shading_field, shd_shading_field_desc, 1, 0)
#undef SHD_SHADING
#endif

#ifdef SHD_FUNCTION_BASED
XREF_DESC_BEGIN (shd_function_based_field_desc, NULL)
     XREF_A_ARRAY ("Domain", struct xref_real_array, domain,
		   &xref_real_pstable, 1, 0, XREF_O)
     COBJ_MATRIX ("Matrix", matrix, 1, 0, XREF_O)
     FUN_FUNCTION_R ("Function", function, 1, 0, XREF_M)
XREF_DESC_END
XREF_F_DICTIONARY (shd_function_based_field, 
		   shd_function_based_field_desc, 1, 0)
#undef SHD_FUNCTION_BASED
#endif

#ifdef SHD_AXIAL
XREF_DESC_BEGIN (shd_axial_field_desc, NULL)
     XREF_A_ARRAY ("Coords", struct xref_real_array, coords,
		   &xref_real_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("Domain", struct xref_real_array, domain,
		   &xref_real_pstable, 1, 0, XREF_O)
     FUN_FUNCTION_R ("Function", function, 1, 0, XREF_M)
     XREF_A_ARRAY ("Extend", struct xref_bool_array, extend,
		   &xref_bool_pstable, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (shd_axial_field, shd_axial_field_desc, 1, 0)
#undef SHD_AXIAL
#endif

#ifdef SHD_RADIAL
XREF_DESC_BEGIN (shd_radial_field_desc, NULL)
     XREF_A_ARRAY ("Coords", struct xref_real_array, coords,
		   &xref_real_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("Domain", struct xref_real_array, domain,
		   &xref_real_pstable, 1, 0, XREF_O)
     FUN_FUNCTION_R ("Function", function, 1, 0, XREF_M)
     XREF_A_ARRAY ("Extend", struct xref_bool_array, extend,
		   &xref_bool_pstable, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (shd_radial_field, shd_radial_field_desc, 1, 0)
#undef SHD_RADIAL
#endif

#ifdef SHD_FREE_GOURAUD
XREF_DESC_BEGIN (shd_free_gouraud_field_desc, NULL)
     XREF_INTEGER ("BitsPerCoordinate", bits_per_coordinate, -1, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerComponent", bits_per_component, -1, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerFlag", bits_per_flag, -1, 1, 0, XREF_M)
     XREF_A_ARRAY ("Decode", struct xref_real_array, decode,
		   &xref_real_pstable, 1, 0, XREF_M)
     FUN_FUNCTION_R ("Function", function, 1, 0, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (shd_free_gouraud_field, shd_free_gouraud_field_desc, 1, 0)
#undef SHD_FREE_GOURAUD
#endif

#ifdef SHD_LATTICE_GOURAUD
XREF_DESC_BEGIN (shd_lattice_gouraud_field_desc, NULL)
     XREF_INTEGER ("BitsPerCoordinate", bits_per_coordinate, -1, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerComponent", bits_per_component, -1, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerFlag", bits_per_flag, -1, 1, 0, XREF_M)
     XREF_A_ARRAY ("Decode", struct xref_real_array, decode,
		   &xref_real_pstable, 1, 0, XREF_M)
     FUN_FUNCTION_R ("Function", function, 1, 0, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (shd_lattice_gouraud_field, shd_lattice_gouraud_field_desc, 1, 0)
#undef SHD_LATTICE_GOURAUD
#endif

#ifdef SHD_COONS_PATCH
XREF_DESC_BEGIN (shd_coons_patch_field_desc, NULL)
     XREF_INTEGER ("BitsPerCoordinate", bits_per_coordinate, -1, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerComponent", bits_per_component, -1, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerFlag", bits_per_flag, -1, 1, 0, XREF_M)
     XREF_A_ARRAY ("Decode", struct xref_real_array, decode,
		   &xref_real_pstable, 1, 0, XREF_M)
     FUN_FUNCTION_R ("Function", function, 1, 0, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (shd_coons_patch_field, shd_coons_patch_field_desc, 1, 0)
#undef SHD_COONS_PATCH
#endif

#ifdef SHD_TENSOR_PATCH
XREF_DESC_BEGIN (shd_tensor_patch_field_desc, NULL)
     XREF_INTEGER ("BitsPerCoordinate", bits_per_coordinate, -1, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerComponent", bits_per_component, -1, 1, 0, XREF_M)
     XREF_INTEGER ("BitsPerFlag", bits_per_flag, -1, 1, 0, XREF_M)
     XREF_A_ARRAY ("Decode", struct xref_real_array, decode,
		   &xref_real_pstable, 1, 0, XREF_M)
     FUN_FUNCTION_R ("Function", function, 1, 0, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (shd_tensor_patch_field, shd_tensor_patch_field_desc, 1, 0)
#undef SHD_TENSOR_PATCH
#endif


