/*
 * PDFlow -- tree.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef tree_h

#define tree_h

#include "btree.h"
#include "types/types.h"
#include "types/txtstring.h"

struct tr_cursor;

struct tr_tree {

	struct t_type t;

	struct bt_tree *tree;

	struct tr_node *delnodes;

	struct tree_ifc *ifc;
};

T_PROTOTYPES (tr_num, tr_tree);
T_PROTOTYPES (tr_name, tr_tree);

#define T_NUM_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct tr_tree, field, \
                 &tr_num_pstable, major, minor, mand)

#define T_NAME_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct tr_tree, field, \
                 &tr_name_pstable, major, minor, mand)


enum s_status tr_num_lookup (struct tr_tree *tree,
			     pdf_integer_t key, struct obj *val);
enum s_status tr_name_lookup (struct tr_tree *tree,
			      struct obj_bstr key, struct obj *val);

#endif
