/*
 * PDFlow -- xobj.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef xobj_h

#define xobj_h

#include "refs.h"
#include "fmt/obj.h"
#include "types/cobj.h"
#include "types/resdict.h"
#include "types/oc.h"
#include "types/types.h"
#include "graph/gstate.h"

T_PROTOTYPES (xo, xo_object);
T_PROTOTYPES (xo_form_group, xo_form_group);
T_PROTOTYPES (xo_form_reference, xo_form_reference);
T_PROTOTYPES (xo_image, xo_image);
T_PROTOTYPES (xo_alt_image, xo_alt_image);

#define XO_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct xo_object, field, \
                 &xo_pstable, major, minor, mand)

#define XO_FORM_GROUP_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct xo_form_group, field, \
                 &xo_form_group_pstable, major, minor, mand)

#define XO_FORM_REFERENCE_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct xo_form_reference, field, \
                 &xo_form_reference_pstable, major, minor, mand)

#define XO_ALT_IMAGE_FIELD_R(name, field, major, minor, mand) \
XREF_FUNCTION_R (name, struct xo_alt_image, field, \
                 &xo_alt_image_pstable, major, minor, mand)

enum xo_subtype {
	
	XO_T_NONE,

	XO_T_PS,
	XO_T_FORM,
	XO_T_IMAGE
};

enum xo_subtype2 {
	
	XO_T2_NONE,

	XO_T2_PS
};

struct xo_ps {

#define XO_PS
#include "xobj.tab.h"
};

enum xo_img_mask_in_data {

	XO_I_MID_IGNORE,
	XO_I_MID_SOFT_MASK,
	XO_I_MID_OPACITY_CHANNEL

};

enum xo_form_type {
	XO_F_T_DEFAULT = 1
};


enum xo_group_subtype {
	XO_GS_TRANSPARENCY
};

struct xo_image {

#define XO_IMAGE
#include "xobj.tab.h"
};

struct xo_alt_image {
	
	struct t_type t;

#define XO_ALT_IMAGE
#include "xobj.tab.h"
};

struct xo_form_group {

	struct t_type t;

#define XO_FORM_GROUP
#include "xobj.tab.h"
};

struct xo_form_reference {

	struct t_type t;

#define XO_FORM_REFERENCE
#include "xobj.tab.h"
};

struct xo_form {
       
#define XO_FORM
#include "xobj.tab.h"
};

union xo_data {
	struct xo_ps ps;
	struct xo_image image;
	struct xo_form form;
};

struct xo_object {

	struct t_type t;

	struct xo_ifc *ifc;

#define XO_OBJECT
#include "types/xobj.tab.h"

};

enum xo_subtype xo_get_subtype (struct xo_object *xo);

#endif
