/*
 * PDFlow -- xobj.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef XO_OBJECT
XREF_DESC_BEGIN (xo_object_field_desc, NULL)
     XREF_TAG ("Type", "XObject", 1, 0, XREF_O)
     COBJ_ENUM ("Subtype", subtype, subtype_desc, 1, 0, XREF_M)
     COBJ_ENUM ("Subtype2", subtype2, subtype2_desc, 1, 0, XREF_O)
     XREF_OBJ ("Metadata", metadata, OT_STREAM, 1, 4, XREF_O)
     XREF_OBJ ("OPI", opi, OT_DICTIONARY, 1, 5, XREF_O)
     XREF_INTEGER ("StructParent", struct_parent, -1, 1, 3, XREF_O)
     XREF_OBJ ("Name", name, OT_NAME, 1, 0, XREF_O)
     OC_REFERENCE_FIELD_I ("OC", oc, 1, 5, XREF_O)
     XREF_DYN (union xo_data, u, dyn_ifc)
XREF_DESC_END
XREF_F_DICTIONARY (xo_object_field, xo_object_field_desc, 1, 0)
#undef XO_OBJECT
#endif

#ifdef XO_FORM
XREF_DESC_BEGIN (xo_form_field_desc, NULL)
     XREF_INTEGER ("FormType", form_type, 1, 1, 0, XREF_O)
     COBJ_RECT ("BBox", bbox, 1, 0, XREF_O)
     COBJ_MATRIX ("Matrix", matrix, 1, 0, XREF_O)
     RD_FIELD_R ("Resources", resources, 1, 2, XREF_O)
     XO_FORM_GROUP_FIELD_R ("Group", group, 1, 4, XREF_O)
     XO_FORM_REFERENCE_FIELD_R ("Ref", ref, 1, 4, XREF_O)
     XREF_OBJ ("PieceInfo", piece_info, OT_DICTIONARY, 1, 3, XREF_O)
     COBJ_DATE ("LastModified", last_modified, 1, 3, XREF_O)
     XREF_INTEGER ("StructParents", struct_parents, -1, 1, 3, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (xo_form_field, xo_form_field_desc, 1, 0)
#undef XO_FORM
#endif

#ifdef XO_FORM_GROUP
XREF_DESC_BEGIN (xo_form_group_field_desc, NULL)
     XREF_TAG ("Type", "Group", 1, 0, XREF_O)
     COBJ_ENUM ("S", subtype, group_subtype_desc, 1, 0, XREF_M)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (xo_form_group_field, xo_form_group_field_desc, 1, 0)
#undef XO_FORM_GROUP
#endif

#ifdef XO_FORM_REFERENCE
XREF_DESC_BEGIN (xo_form_reference_field_desc, NULL)
     XREF_TAG ("Type", "Group", 1, 0, XREF_O)
     XREF_OBJ ("Page", page, OT_ANY, 1, 0, XREF_M)
     COBJ_ID ("ID", id, 1, 0, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (xo_form_reference_field, xo_form_reference_field_desc, 1, 0)
#undef XO_FORM_REFERENCE
#endif

#ifdef XO_IMAGE
XREF_DESC_BEGIN (xo_image_field_desc, NULL)
     XREF_INTEGER ("Width", width, 0, 1, 0, XREF_M)
     XREF_INTEGER ("Height", height, 0, 1, 0, XREF_M)
     GC_CSPACE_FIELD_R ("ColorSpace", color_space, 1, 0, XREF_O)
     XREF_INTEGER ("BitsPerComponent", bpc, 0, 1, 0, XREF_O)
     COBJ_ENUM ("Intent", intent, gs_rendering_intent_desc, 1, 1, XREF_O)
     XREF_BOOL ("ImageMask", image_mask, 0, 1, 0, XREF_O)
     XREF_OBJ ("Mask", mask, OT_ANY, 1, 3, XREF_O)
     XREF_A_ARRAY ("Decode", struct xref_real_array, decode,
		   &xref_real_pstable, 1, 0, XREF_O)
     XREF_BOOL ("Interpolate", interpolate, 0, 1, 0, XREF_O)
     XREF_A_ARRAY ("Alternates", struct xo_image_array, alternates,
		   &xo_alt_image_pstable, 1, 3, XREF_O)
     XO_FIELD_R ("SMask", smask, 1, 4, XREF_O)
     XREF_INTEGER ("SMaskInData", smask_in_data, 0, 1, 5, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (xo_image_field, xo_image_field_desc, 1, 0)
#undef XO_IMAGE
#endif

#ifdef XO_ALT_IMAGE
XREF_DESC_BEGIN (xo_alt_image_field_desc, NULL)
     XO_FIELD_R ("Image", image, 1, 0, XREF_M)
     XREF_BOOL ("DefaultForPrinting", def_for_printing, 0, 1, 0, XREF_O)
     OC_REFERENCE_FIELD_I ("OC", oc, 1, 5, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (xo_alt_image_field, xo_alt_image_field_desc, 1, 0)
#undef XO_ALT_IMAGE
#endif

#ifdef XO_PS
XREF_DESC_BEGIN (xo_ps_field_desc, NULL)
     XREF_OBJ ("Level1", level1, OT_STREAM, 1, 0, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (xo_ps_field, xo_ps_field_desc, 1, 0)
#undef XO_PS
#endif
