/*
 * PDFlow -- colour_pst.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifndef colour_pst_h

#define colour_pst_h

#include "types/colour.h"


/* Low level pstables */
extern struct xref_pstable gc_cf_cal_gray_pstable;
extern struct xref_pstable gc_cf_cal_rgb_pstable;
extern struct xref_pstable gc_cf_lab_pstable;
extern struct xref_pstable gc_cf_icc_based_pstable;
extern struct xref_pstable gc_cf_device_n_pstable;
extern struct xref_pstable gc_lookup_pstable;

#define GC_CAL_GRAY(name, field, major, minor, status) \
XREF_FUNCTION_I (name, struct gc_d_cie, field, \
                 gc_cf_cal_gray_pstable, major, minor, status)
#define GC_F_CAL_GRAY(name, major, minor) \
XREF_F_FUNCTION (name, gc_cf_cal_gray_pstable, major, minor)

#define GC_CAL_RGB(name, field, major, minor, status) \
XREF_FUNCTION_I (name, struct gc_d_cie, field, \
                 gc_cf_cal_rgb_pstable, major, minor, status)
#define GC_F_CAL_RGB(name, major, minor) \
XREF_F_FUNCTION (name, gc_cf_cal_rgb_pstable, major, minor)

#define GC_LAB(name, field, major, minor, status) \
XREF_FUNCTION_I (name, struct gc_d_cie, field, \
                 gc_cf_lab_pstable, major, minor, status)
#define GC_F_LAB(name, major, minor) \
XREF_F_FUNCTION (name, gc_cf_lab_pstable, major, minor)

#define GC_ICC_BASED(name, field, major, minor, status) \
XREF_FUNCTION_I (name, struct gc_d_icc_based, field, \
                 gc_cf_icc_based_pstable, major, minor, status)
#define GC_F_ICC_BASED(name, major, minor) \
XREF_F_FUNCTION (name, gc_cf_icc_based_pstable, major, minor)

#define GC_DEVICE_N(name, field, major, minor, status) \
XREF_FUNCTION_I (name, struct gc_d_device_n, field, \
                 gc_cf_device_n_pstable, major, minor, status)
#define GC_F_DEVICE_N(name, major, minor) \
XREF_F_FUNCTION (name, gc_cf_device_n_pstable, major, minor)

#endif
