/*
 * PDFlow -- colour_pst.tab.h
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#include "fmt/fields.tab.h"

#ifdef PST_CIE
XREF_DESC_BEGIN (pst_cie_field_desc, NULL)
     XREF_A_ARRAY ("WhitePoint", struct xref_real_array, white_point, 
		   &xref_real_pstable, 1, 0, XREF_M)
     XREF_S_ARRAY ("BlackPoint", struct xref_real_array, black_point, 
		   &xref_real_pstable, 1, 0, XREF_O)
     XREF_S_ARRAY ("Gamma", struct xref_real_array, gamma, 
		   &xref_real_pstable, 1, 0, XREF_O)
     COBJ_MATRIX9 ("Matrix", matrix, 1, 0, XREF_O)
     XREF_A_ARRAY ("Range", struct xref_real_array, range, 
		   &xref_real_pstable, 1, 0, XREF_O)
XREF_DESC_END
XREF_F_DICTIONARY (pst_cie_field, pst_cie_field_desc, 1, 1)
#undef PST_CIE
#endif

#ifdef PST_ICC
XREF_DESC_BEGIN (pst_icc_field_desc, NULL)
     XREF_INTEGER ("N", n, 0, 1, 0, XREF_M)
     XREF_FUNCTION_I ("Alternate", struct gc_colour_space *, 
		      alternate, &gc_cspace_pstable, 1, 0, XREF_O)
     XREF_A_ARRAY ("Range", struct xref_real_array, range, 
		   &xref_real_pstable, 1, 0, XREF_O)
     XREF_OBJ ("Metadata", metadata, OT_STREAM, 1, 4, XREF_O)
     XREF_REGION (data)
XREF_DESC_END
XREF_F_STREAM (pst_icc_field, pst_icc_field_desc, 1, 1)
#undef PST_ICC
#endif

#ifdef PST_DEVICE_N
XREF_DESC_BEGIN (pst_device_n_field_desc, NULL)
     XREF_TAG ("1-ColourSpace", "DeviceN", 1, 0, XREF_M)
     XREF_S_ARRAY ("2-Names", struct xref_obj_array, names,
		   &xref_name_pstable, 1, 0, XREF_M)
     GC_CSPACE_FIELD_R ("3-AlternateSpace", alternate_space, 1, 0, XREF_M)
     FUN_FUNCTION_R ("4-TintTransform", tint_transform, 1, 0, XREF_M)
     XREF_NEST ("5-Attributes", struct pst_devn_attr, attributes, 
		OT_DICTIONARY, &pst_devn_attr_field_desc, 1, 3, XREF_O)
XREF_DESC_END
XREF_F_S_ARRAY (pst_device_n_field, pst_device_n_field_desc, 1, 3)
#undef PST_DEVICE_N
#endif

#ifdef PST_DEVN_ATTR
XREF_DESC_BEGIN (pst_devn_attr_field_desc, NULL)
     COBJ_ENUM ("Subtype", subtype, subtype_desc, 1, 6, XREF_O)
     XREF_OBJ ("Colorants", colorants, OT_DICTIONARY, 1, 0, XREF_O)
     XREF_NEST ("Process", struct pst_devn_process, process,
		OT_DICTIONARY, &pst_devn_process_field_desc, 1, 0, XREF_O)
     XREF_NEST ("MixingHints", struct pst_devn_mixing_hints, mixing_hints,
		OT_DICTIONARY, &pst_devn_mixing_hints_field_desc, 1, 6, XREF_O)
XREF_DESC_END
#undef PST_DEVN_ATTR
#endif

#ifdef PST_DEVN_PROCESS
XREF_DESC_BEGIN (pst_devn_process_field_desc, NULL)
     XREF_FUNCTION_I ("ColorSpace", struct gc_colour_space *, 
		      color_space, &gc_cspace_pstable, 1, 0, XREF_M)
     XREF_A_ARRAY ("Components", struct xref_obj_array, components, 
		   &xref_name_pstable, 1, 0, XREF_M)
XREF_DESC_END
#undef PST_DEVN_PROCESS
#endif

#ifdef PST_DEVN_MIXING_HINTS
XREF_DESC_BEGIN (pst_devn_mixing_hints_field_desc, NULL)
     XREF_OBJ ("Solidities", solidities, OT_DICTIONARY, 1, 0, XREF_O)
     XREF_A_ARRAY ("PrintingOrder", struct xref_obj_array, printing_order, 
		   &xref_name_pstable, 1, 0, XREF_M)
     XREF_OBJ ("DotGain", dot_gain, OT_DICTIONARY, 1, 0, XREF_O)
XREF_DESC_END
#undef PST_DEVN_MIXING_HINTS
#endif
