/*
 * PDFlow -- extensions.c
 *
 *  Copyright (c) 2010 Alberto Cuda
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdlib.h>
#include <string.h>

#include "version.h"
#include "types/extensions.h"

#define XREF_IMPLEMENTATION struct xts_extensions
#define XTS_EXTENSIONS
#include "types/extensions.tab.h"
#undef XREF_IMPLEMENTATION

#define XREF_IMPLEMENTATION struct xts_info
#define XTS_INFO
#include "types/extensions.tab.h"
#undef XREF_IMPLEMENTATION

T_IMPLEMENTATIONS (xts_extensions, xts_extensions, &xts_extensions_field);
T_IMPLEMENTATIONS (xts_info, xts_info, &xts_info_field);


enum s_status xts_get_info (struct xts_extensions *xts,
			    const char *name, struct ref_owner *p,
			    struct xts_info **info)
{
	enum s_status res;
	struct obj obj;

	res = xref_dict_resolve (xts -> t.rdb, &xts -> t.obj, name,
				 OT_DICTIONARY, &obj);
	if (res != S_CSC_OK)
		return res;

	if (obj.type == OT_NULL) {
		*info = NULL;
		return S_CSC_OK;
	}


	res = T_CALL (xts_info_init, info, xts -> t.rdb, NULL, &obj, p);
	obj_destroy (&obj);

	return res;
}

